diff -crN nakedmudv1.5/src/login.c nakedmudv2.0/src/login.c
*** nakedmudv1.5/src/login.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/login.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,328 ----
+ //*****************************************************************************
+ //
+ // login.c
+ //
+ // Different muds will want to set up the login process in very different ways;
+ // as such, I figured it would be good to localize all of the login details to
+ // a single file for people to tailor to their specific mud. It also makes
+ // updating to newer versions a bit easier. Your login procedure should be laid
+ // out here. A basic framework is given, but it could use lots of work. In fact,
+ // it is crap and could use LOTS of work. I encourage people to write their own
+ // login procedure and submit their designs to me so I can develop a better
+ // general method for later versions of the mud.
+ //
+ //*****************************************************************************
+ 
+ #include "mud.h"
+ #include "utils.h"
+ #include "socket.h"
+ #include "character.h"
+ #include "handler.h"
+ #include "inform.h"
+ #include "world.h"
+ #include "races.h"
+ #include "save.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "scripts/script.h"
+ 
+ 
+ 
+ // mccp support
+ const unsigned char do_echo         [] = { IAC, WONT, TELOPT_ECHO,      '\0' };
+ const unsigned char dont_echo       [] = { IAC, WILL, TELOPT_ECHO,      '\0' };
+ 
+ 
+ // input handlers
+ void state_new_name       (SOCKET_DATA *dsock, char *arg);
+ void state_ask_password   (SOCKET_DATA *dsock, char *arg);
+ void state_new_password   (SOCKET_DATA *dsock, char *arg);
+ void state_verify_password(SOCKET_DATA *dsock, char *arg);
+ void state_ask_sex        (SOCKET_DATA *dsock, char *arg);
+ void state_ask_race       (SOCKET_DATA *dsock, char *arg);
+ 
+ 
+ 
+ //
+ // the head honcho. This is the first handler that a socket enters once it has
+ // connected to the game. You should use this function to get your login 
+ // procedure rolling.
+ void handle_new_connections(SOCKET_DATA *dsock, char *arg) {
+   state_new_name(dsock, arg);
+ }
+ 
+ 
+ 
+ 
+ //*****************************************************************************
+ // Contained blow are the functions required for logging on an old character,
+ // or creating a new character. Hmmm, wouldn't it be nice if players had one 
+ // account where they could have all their multiple characters listed, as
+ // opposed to a bunch of different characters? Perhaps this is something to
+ // consider for later versions of the MUD.
+ //*****************************************************************************
+ 
+ //
+ // Ask a new connection for a name. This is the first thing that is called
+ // whenever a new socket connects to us
+ void state_new_name(SOCKET_DATA *dsock, char *arg) {
+   CHAR_DATA *p_new;
+ 
+   if (socketGetDNSLookupStatus(dsock) != TSTATE_DONE) {
+     text_to_buffer(dsock, 
+ 		   "Making a dns lookup, please have patience.\n\r"
+ 		   "What is your name? ");
+     return;
+   }
+   // check for a legal name
+   if (!check_name(arg)) {
+     text_to_buffer(dsock, 
+ 		   "Sorry, that's not a legal name, please pick another.\n\r"
+ 		   "What is your name? ");
+     return; // break;
+   }
+   arg[0] = toupper(arg[0]);
+   log_string("%s is trying to connect.", arg);
+ 
+ 
+   // Check for a new Player 
+   if ((p_new = load_profile(arg)) == NULL) {
+     p_new = newChar();
+ 
+     // give the player it's name 
+     charSetName(p_new, arg);
+ 
+     // and room description. In the future, we may want
+     // to consider allowing players to set their own rdescs 
+     char rdesc[SMALL_BUFFER];
+     sprintf(rdesc, "%s is here.", arg);
+     charSetRdesc(p_new, rdesc);
+ 
+     // prepare for next step 
+     text_to_buffer(dsock, "Please enter a new password: ");
+     socketReplaceInputHandler(dsock, state_new_password, NULL);
+   }
+   // old player
+   else {
+     // prepare for next step 
+     text_to_buffer(dsock, "What is your password? ");
+     socketReplaceInputHandler(dsock, state_ask_password, NULL);
+   }
+   text_to_buffer(dsock, (char *)dont_echo);
+ 
+   // socket <-> player 
+   charSetSocket(p_new, dsock);
+   socketSetChar(dsock, p_new);
+ }
+ 
+ 
+ //
+ // Ask a character for a password. This is only called once, when
+ // the character first creates.
+ void state_new_password(SOCKET_DATA *dsock, char *arg) {
+   if (strlen(arg) < 5 || strlen(arg) > 12) {
+     text_to_buffer(dsock, 
+ 		   "\r\nBetween 5 and 12 chars please!\n\r"
+ 		   "Please enter a new password: ");
+     return;
+   }
+   charSetPassword(socketGetChar(dsock), 
+ 		  crypt(arg, charGetName(socketGetChar(dsock))));
+ 
+   //
+   // Why is this here? Is this because of old pfiles that terminated strings
+   // with a tilde?
+   //   - Geoff, Mar 21/05
+   if(strchr(charGetPassword(socketGetChar(dsock)), '~') != NULL) {
+       text_to_buffer(dsock, "Illegal password!\n\r"
+ 		            "Please enter a new password: ");
+   }
+   else {
+     text_to_buffer(dsock, "\r\nPlease verify the password: ");
+     socketReplaceInputHandler(dsock, state_verify_password, NULL);
+   }
+ }
+ 
+ 
+ //
+ // Verify that the character's new password is correct. This is
+ // only called once, when the character creates
+ void state_verify_password(SOCKET_DATA *dsock, char *arg) {
+   if (compares(crypt(arg, charGetName(socketGetChar(dsock))), 
+ 	       charGetPassword(socketGetChar(dsock)))) {
+     text_to_buffer(dsock, (char *) do_echo);
+ 
+     // onto the sex check 
+     text_to_buffer(dsock, "\r\nWhat is your sex (M/F/N): ");
+     socketReplaceInputHandler(dsock, state_ask_sex, NULL);
+   }
+   else {
+     charSetPassword(socketGetChar(dsock), NULL);
+     text_to_buffer(dsock, 
+ 		   "\r\nPassword mismatch!\n\r"
+ 		   "Please enter a new password: ");
+     socketReplaceInputHandler(dsock, state_new_password, NULL);
+   }
+ }
+ 
+ void list_races(SOCKET_DATA *sock) {
+   send_to_socket(sock, "Available races are:\r\n");
+   send_to_socket(sock, "%s", raceGetList(TRUE));
+   send_to_socket(sock, "\r\n\r\nPlease enter your choice: ");
+ }
+ 
+ //
+ // Ask for the character's race. Called each time a character is created
+ void state_ask_race(SOCKET_DATA *dsock, char *arg) {
+   if(!arg || !*arg || !raceIsForPC(arg)) {
+     send_to_socket(dsock, "Invalid race! Please try again: ");
+     return;
+   }    
+   else {
+     charSetRace(socketGetChar(dsock), arg);
+     charResetBody(socketGetChar(dsock));
+   }
+ 
+   // give the character a unique id 
+   charSetUID(socketGetChar(dsock), next_char_uid());
+ 
+   // if it's the first player, set him as the highest level 
+   if(charGetUID(socketGetChar(dsock)) == 1)
+     charSetLevel(socketGetChar(dsock), MAX_LEVEL);
+ 
+   // add the character to the game 
+   char_to_game(socketGetChar(dsock));
+ 
+   log_string("New player: %s has entered the game.", 
+ 	     charGetName(socketGetChar(dsock)));
+     
+   // and into the game 
+   // pop the input handler for char creation and add the one for
+   // playing the game
+   socketReplaceInputHandler(dsock, handle_cmd_input, show_prompt);
+   text_to_buffer(dsock, motd);
+ 
+   // we should do some checks here to make sure the start room exists
+   char_to_room(socketGetChar(dsock), worldGetRoom(gameworld, START_ROOM));
+   look_at_room(socketGetChar(dsock), charGetRoom(socketGetChar(dsock)));
+ 
+   // and save him 
+   save_player(socketGetChar(dsock));
+ 
+   // check enterance scripts
+   try_enterance_script(socketGetChar(dsock), charGetRoom(socketGetChar(dsock)), NULL);
+ }
+ 
+ //
+ // Ask for the character's sex. This will be called each time the
+ // character creates
+ void state_ask_sex(SOCKET_DATA *dsock, char *arg) {
+   switch(*arg) {
+   case 'f':
+   case 'F':
+     charSetSex(socketGetChar(dsock), SEX_FEMALE);
+     break;
+   case 'm':
+   case 'M':
+     charSetSex(socketGetChar(dsock), SEX_MALE);
+     break;
+   case 'n':
+   case 'N':
+     charSetSex(socketGetChar(dsock), SEX_NEUTRAL);
+     break;
+   default:
+     text_to_buffer(dsock, "\r\nInvalid sex. Try again (M/F/N) :");
+     return;
+   }
+ 
+   // onto the password check 
+   socketReplaceInputHandler(dsock, state_ask_race, NULL);
+   list_races(dsock);
+ }
+ 
+ 
+ //
+ // Ask the character for his or her password. This will be called
+ // every time the character logs on, after the first time when the
+ // character creates
+ void state_ask_password(SOCKET_DATA *dsock, char *arg) {
+   CHAR_DATA *p_new;
+ 
+   text_to_buffer(dsock, (char *) do_echo);
+   if (compares(crypt(arg, charGetName(socketGetChar(dsock))), 
+ 	       charGetPassword(socketGetChar(dsock))))
+   {
+     if ((p_new = check_reconnect(charGetName(socketGetChar(dsock)))) != NULL) {
+       // we do NOT want to extract, here... the player hasn't even
+       // entered the game yet. We just want to DELETE the profile character
+       deleteChar(socketGetChar(dsock));
+ 
+       // attach the new player 
+       socketSetChar(dsock, p_new);
+       charSetSocket(p_new, dsock);
+ 
+       log_string("%s has reconnected.", charGetName(socketGetChar(dsock)));
+ 
+       // and let him enter the game 
+       // pop the input handler for char creation and add the one for
+       // playing the game
+       socketReplaceInputHandler(dsock, handle_cmd_input, show_prompt);
+       text_to_buffer(dsock, "You take over a body already in use.\n\r");
+     }
+     else if ((p_new = load_player(charGetName(socketGetChar(dsock)))) == NULL) {
+       text_to_socket(dsock, "ERROR: Your pfile is missing!\n\r");
+       // no extract, just delete! We haven't entered the game yet,
+       // so there is no need to extract
+       deleteChar(socketGetChar(dsock));
+ 
+       socketSetChar(dsock, NULL);
+       close_socket(dsock, FALSE);
+       return;
+     }
+     else {
+       // No extract, just delete. We have not entered the game yet,
+       // so there is no need to extract from it.
+       deleteChar(socketGetChar(dsock));
+ 
+       // attach the new player 
+       socketSetChar(dsock, p_new);
+       charSetSocket(p_new, dsock);
+ 
+       // try putting the character into the game.
+       // Close the socket if we fail
+       if(try_enter_game(p_new)) {
+ 	log_string("%s has entered the game.", charGetName(p_new));
+ 	// we're no longer in the creation process... attach the game
+ 	// input handler
+ 	socketReplaceInputHandler(dsock, handle_cmd_input, show_prompt);
+ 
+ 	text_to_buffer(dsock, motd);
+ 	look_at_room(p_new, charGetRoom(p_new));
+ 
+ 	// check enterance scripts
+ 	try_enterance_script(p_new, charGetRoom(p_new), NULL);
+       }
+       else {
+ 	// do not extract, just delete. We failed to enter
+ 	// the game, so there is no need to extract from the game.
+ 	deleteChar(socketGetChar(dsock));
+ 
+ 	socketSetChar(dsock, NULL);
+ 	close_socket(dsock, FALSE);
+       }
+     }
+   }
+   else {
+     text_to_socket(dsock, "Bad password!\n\r");
+     // do not extract, just delete. We have not entered the game
+     // yet, so there is no need to extract from the game.
+     deleteChar(socketGetChar(dsock));
+ 
+     socketSetChar(dsock, NULL);
+     close_socket(dsock, FALSE);
+   }
+ }
diff -crN nakedmudv1.5/src/login.d nakedmudv2.0/src/login.d
*** nakedmudv1.5/src/login.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/login.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ login.d login.o: login.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h socket.h character.h \
+   handler.h inform.h world.h races.h save.h scripts/script.h
diff -crN nakedmudv1.5/src/Makefile nakedmudv2.0/src/Makefile
*** nakedmudv1.5/src/Makefile	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/Makefile	2010-11-01 15:54:18.000000000 -0500
***************
*** 13,20 ****
  # compiler to use
  CC = gcc
  
! # the modules we have installed
! MODULES := time alias char_vars socials olc scripts help
  
  # flags to use during compilation
  C_FLAGS := -Wall -g -ggdb -O2
--- 13,24 ----
  # compiler to use
  CC = gcc
  
! # the modules we have installed -- mandatory modules go here
! MODULES := char_vars set_val olc2 editor items scripts
! 
! # optional modules go on this line
! MODULES += time socials alias help
! 
  
  # flags to use during compilation
  C_FLAGS := -Wall -g -ggdb -O2
***************
*** 22,41 ****
  # extra libraries if required
  LIBS    := -lz -lpthread -lcrypt
  
  # each module will add to this from its module.mk file
  SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c movement.c \
  	   action.c mccp.c save.c socket.c io.c strings.c event.c \
  	   \
  	   cmd_comm.c cmd_manip.c cmd_misc.c cmd_admin.c cmd_builder.c \
  	   \
! 	   text_editor.c races.c \
  	   \
! 	   items.c log.c auxiliary.c \
  	   \
  	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
  	   zone.c dialog.c room_reset.c \
  	   \
! 	   list.c property_table.c hashtable.c hashmap.c storage.c set.c
  
  
  # include the description for each module. These will add to SRC
--- 26,47 ----
  # extra libraries if required
  LIBS    := -lz -lpthread -lcrypt
  
+ 
  # each module will add to this from its module.mk file
  SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c movement.c \
  	   action.c mccp.c save.c socket.c io.c strings.c event.c \
  	   \
  	   cmd_comm.c cmd_manip.c cmd_misc.c cmd_admin.c cmd_builder.c \
  	   \
! 	   races.c \
  	   \
! 	   log.c auxiliary.c login.c \
  	   \
  	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
  	   zone.c dialog.c room_reset.c \
  	   \
! 	   list.c property_table.c hashtable.c map.c storage.c set.c \
! 	   buffer.c bitvector.c
  
  
  # include the description for each module. These will add to SRC
***************
*** 48,56 ****
  
  
  ################################################################################
- #
  # make commands
- #
  ################################################################################
  all: $(O_FILES)
  	$(CC) -o NakedMud $(O_FILES) $(LIBS)
--- 54,60 ----
***************
*** 62,73 ****
  # say where the .o files need to go
  .c.o: all
  	$(CC) -c $(C_FLAGS) -o $(patsubst %.c,%.o, $<) $<
- #	$(CC) -c $(C_FLAGS) $<
- 
- 
- # make dependancies for all of the files
- depend:
- 	$(CC) -MM $(filter %.c, $(SRC)) > .depend
  
  # clear all of the .o files and all of the save files that emacs makes
  clean:
--- 66,71 ----
***************
*** 77,80 ****
  	rm -f *~
  	rm -f */*~
  
! include .depend
--- 75,83 ----
  	rm -f *~
  	rm -f */*~
  
! # include all of our dependencies
! include $(patsubst %.c,%.d, $(SRC))
! 
! # calculate all of our dependencies
! %.d: %.c
! 	./depend.sh $(patsubst %.d,%.c, $@) > $@
diff -crN nakedmudv1.5/src/map.c nakedmudv2.0/src/map.c
*** nakedmudv1.5/src/map.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/map.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,263 ----
+ //*****************************************************************************
+ //
+ // map.c
+ //
+ // similar to a hashtable, but keys as well as values can be can be anything.
+ //
+ //*****************************************************************************
+ 
+ #include <stdlib.h>
+ #include "list.h"
+ #include "map.h"
+ 
+ int gen_hash_cmp(const void *key1, const void *key2) {
+   int val = (key2 - key1);
+   if(val < 0)      return -1;
+   else if(val > 0) return  1;
+   else             return  0;
+   return val;
+ }
+ 
+ int gen_hash_func(const void *key) {
+   int val = (int)key;
+   if(val < 0) return -val;
+   else        return  val;
+ }
+ 
+ struct map_iterator {
+   int curr_bucket;
+   MAP *map;
+   LIST_ITERATOR *bucket_i;
+ };
+ 
+ typedef struct map_entry {
+   void *key;
+   void *val;
+ } MAP_ENTRY;
+ 
+ struct map_data {
+   int num_buckets;
+   struct list **buckets;
+   int (* hash_func)(const void *key);
+   int (*  compares)(const void *key1, const void *key2);
+ };
+ 
+ 
+ //
+ // an internal form of hashGet that returns the entire entry (key and val)
+ //
+ MAP_ENTRY *mapGetEntry(MAP *map, void *key) {
+   int bucket = map->hash_func(key) % map->num_buckets;
+ 
+   if(map->buckets[bucket] == NULL)
+     return NULL;
+   else {
+     struct list_iterator *list_i = newListIterator(map->buckets[bucket]);
+     MAP_ENTRY *elem   = NULL;
+ 
+     for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
+       if(!map->compares(key, elem->key))
+ 	break;
+     deleteListIterator(list_i);
+ 
+     return elem;
+   }
+ }
+ 
+ 
+ MAP_ENTRY *newMapEntry(void *key, void *val) {
+   MAP_ENTRY *entry = malloc(sizeof(MAP_ENTRY));
+   entry->key = key;
+   entry->val = val;
+   return entry;
+ }
+ 
+ void deleteMapEntry(MAP_ENTRY *entry) {
+   free(entry);
+ }
+ 
+ 
+ //*****************************************************************************
+ //
+ // implementation of hashmap.h
+ // documentation in hashmap.h
+ //
+ //*****************************************************************************
+ MAP *newMap(void *hash_func, void *compares, int num_buckets) {
+   int i;
+   MAP *map = malloc(sizeof(MAP));
+   map->num_buckets = num_buckets;
+   map->hash_func   = (hash_func ? hash_func : gen_hash_func);
+   map->compares    = (compares  ? compares  : gen_hash_cmp);
+   map->buckets = malloc(sizeof(struct list *) * num_buckets);
+   for(i = 0; i < num_buckets; i++)
+     map->buckets[i] = NULL;
+   return map;
+ }
+ 
+ void  deleteMap(MAP *map) {
+   int i;
+   for(i = 0; i < map->num_buckets; i++) {
+     if(map->buckets[i]) {
+       MAP_ENTRY *entry = NULL;
+       while((entry=(MAP_ENTRY *)listPop(map->buckets[i])) !=NULL)
+ 	deleteMapEntry(entry);
+       deleteList(map->buckets[i]);
+     }
+   }
+   free(map->buckets);
+   free(map);
+ }
+ 
+ int  mapPut    (MAP *map, void *key, void *val) {
+   MAP_ENTRY *elem = mapGetEntry(map, key);
+ 
+   // update the val if it's already here
+   if(elem) {
+     elem->val = val;
+     return 1;
+   }
+   else {
+     int bucket = map->hash_func(key) % map->num_buckets;
+ 
+     // if the bucket doesn't exist yet, create it
+     if(map->buckets[bucket] == NULL)
+       map->buckets[bucket] = newList();
+ 
+     MAP_ENTRY *entry = newMapEntry(key, val);
+     listPut(map->buckets[bucket], entry);
+     return 1;
+   }
+ }
+ 
+ void *mapGet    (MAP *map, void *key) {
+   MAP_ENTRY *elem = mapGetEntry(map, key);
+   if(elem)
+     return elem->val;
+   else
+     return NULL;
+ }
+ 
+ void *mapRemove (MAP *map, void *key) {
+   int bucket = map->hash_func(key) % map->num_buckets;
+ 
+   if(map->buckets[bucket] == NULL)
+     return NULL;
+   else {
+     struct list_iterator *list_i = newListIterator(map->buckets[bucket]);
+     MAP_ENTRY *elem   = NULL;
+ 
+     for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
+       if(!map->compares(key, elem->key))
+ 	break;
+     deleteListIterator(list_i);
+ 
+     if(elem) {
+       void *val = elem->val;
+       listRemove(map->buckets[bucket], elem);
+       deleteMapEntry(elem);
+       return val;
+     }
+     else
+       return NULL;
+   }
+ }
+ 
+ int   mapIn     (MAP *map, void *key) {
+   return (mapGet(map, key) != NULL);
+ }
+ 
+ int   mapSize   (MAP *map) {
+   int i;
+   int size = 0;
+ 
+   for(i = 0; i < map->num_buckets; i++)
+     if(map->buckets[i])
+       size += listSize(map->buckets[i]);
+ 
+   return size;
+ }
+ 
+ 
+ //*****************************************************************************
+ //
+ // implementation of the hashmap iterator
+ // documentation in hashmap.h
+ //
+ //*****************************************************************************
+ MAP_ITERATOR *newMapIterator(MAP *map) {
+   MAP_ITERATOR *I = malloc(sizeof(MAP_ITERATOR));
+   I->map = map;
+   I->bucket_i = NULL;
+   mapIteratorReset(I);
+ 
+   return I;
+ }
+ 
+ void        deleteMapIterator     (MAP_ITERATOR *I) {
+   if(I->bucket_i) deleteListIterator(I->bucket_i);
+   free(I);
+ }
+ 
+ void        mapIteratorReset      (MAP_ITERATOR *I) {
+   int i;
+ 
+   if(I->bucket_i) deleteListIterator(I->bucket_i);
+   I->bucket_i = NULL;
+   I->curr_bucket = 0;
+ 
+   // bucket_i will be NULL if there are no elements
+   for(i = 0; i < I->map->num_buckets; i++) {
+     if(I->map->buckets[i] != NULL &&
+        listSize(I->map->buckets[i]) > 0) {
+       I->curr_bucket = i;
+       I->bucket_i = newListIterator(I->map->buckets[i]);
+       break;
+     }
+   }
+ }
+ 
+ 
+ void        mapIteratorNext       (MAP_ITERATOR *I) {
+   // no elements in the hashmap
+   if(I->bucket_i == NULL)
+     return;
+   // we're at the end of our list
+   else if(listIteratorNext(I->bucket_i) == NULL) {
+     deleteListIterator(I->bucket_i);
+     I->bucket_i = NULL;
+     I->curr_bucket++;
+     
+     for(; I->curr_bucket < I->map->num_buckets; I->curr_bucket++) {
+       if(I->map->buckets[I->curr_bucket] != NULL &&
+ 	 listSize(I->map->buckets[I->curr_bucket]) > 0) {
+ 	I->bucket_i = newListIterator(I->map->buckets[I->curr_bucket]);
+ 	break;
+       }
+     }
+   }
+ }
+ 
+ void *mapIteratorCurrentKey (MAP_ITERATOR *I) {
+   if(!I->bucket_i)
+     return NULL;
+   else {
+     MAP_ENTRY *entry = ((MAP_ENTRY *) listIteratorCurrent(I->bucket_i));
+     if(entry)
+       return entry->key;
+     else
+       return NULL;
+   }
+ }
+ 
+ void       *mapIteratorCurrentVal (MAP_ITERATOR *I) {
+   if(!I->bucket_i) 
+     return NULL;
+   else {
+     MAP_ENTRY *entry = ((MAP_ENTRY *) listIteratorCurrent(I->bucket_i));
+     if(entry)
+       return entry->val;
+     else
+       return NULL;
+   }
+ }
diff -crN nakedmudv1.5/src/map.d nakedmudv2.0/src/map.d
*** nakedmudv1.5/src/map.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/map.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ map.d map.o: map.c list.h map.h
diff -crN nakedmudv1.5/src/map.h nakedmudv2.0/src/map.h
*** nakedmudv1.5/src/map.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/map.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,42 ----
+ #ifndef __MAP_H
+ #define __MAP_H
+ //*****************************************************************************
+ //
+ // map.h
+ //
+ // similar to a hashtable, but keys as well as values can be can be anything.
+ //
+ //*****************************************************************************
+ 
+ typedef struct map_data                   MAP;
+ typedef struct map_iterator               MAP_ITERATOR;
+ 
+ //
+ // if hash_func and/or compares are null, generic hashing and comparing
+ // functions are used.
+ //
+ // hash_func is expected to be a function that takes the key type used in
+ // this map, and returns an integer based on that key.
+ //
+ // compares is expected to be a function that takes two keys and compares
+ // them togher. If they are equal, 0 is returned. if key1 is less than key2,
+ // -1 is returned. otherwise, 1 is returned.
+ //
+ MAP *newMap(void *hash_func, void *compares, int num_buckets);
+ void deleteMap(MAP *map);
+ 
+ int   mapPut    (MAP *map, void *key, void *val);
+ void *mapGet    (MAP *map, void *key);
+ void *mapRemove (MAP *map, void *key);
+ int   mapIn     (MAP *map, void *key);
+ int   mapSize   (MAP *map);
+ 
+ MAP_ITERATOR *newMapIterator(MAP *map);
+ void          deleteMapIterator(MAP_ITERATOR *I);
+ 
+ void  mapIteratorReset      (MAP_ITERATOR *I);
+ void  mapIteratorNext       (MAP_ITERATOR *I);
+ void *mapIteratorCurrentKey (MAP_ITERATOR *I);
+ void *mapIteratorCurrentVal (MAP_ITERATOR *I);
+ 
+ #endif // __MAP_H
diff -crN nakedmudv1.5/src/mccp.d nakedmudv2.0/src/mccp.d
*** nakedmudv1.5/src/mccp.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/mccp.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ mccp.d mccp.o: mccp.c
diff -crN nakedmudv1.5/src/movement.c nakedmudv2.0/src/movement.c
*** nakedmudv1.5/src/movement.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/movement.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 16,28 ****
  #include "handler.h"
  #include "inform.h"
  #include "utils.h"
- #include "items.h"
  #include "object.h"
  
! // optional modules
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
! #endif
  
  
  bool try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir) {
--- 16,32 ----
  #include "handler.h"
  #include "inform.h"
  #include "utils.h"
  #include "object.h"
  
! 
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
! #include "items/items.h"
! #include "items/furniture.h"
! 
  
  
  bool try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir) {
***************
*** 114,120 ****
  
    if(exit == NULL || !can_see_exit(ch, exit)) {
      // see if we can buildwalk a new room
!     if(charIsBitSet(ch, BITFIELD_PRFS, PRF_BUILDWALK))
        return try_buildwalk(ch, dir);
      else
        send_to_char(ch, "Alas, there is no exit in that direction.\r\n");
--- 118,124 ----
  
    if(exit == NULL || !can_see_exit(ch, exit)) {
      // see if we can buildwalk a new room
!     if(bitIsOneSet(charGetPrfs(ch), "buildwalk"))
        return try_buildwalk(ch, dir);
      else
        send_to_char(ch, "Alas, there is no exit in that direction.\r\n");
***************
*** 122,128 ****
    }
  
    else {
- #ifdef MODULE_SCRIPTS
      ROOM_DATA *old_room = charGetRoom(ch);
      bool success = try_exit(ch, exit, dir);
      if(success) {
--- 126,131 ----
***************
*** 132,140 ****
  			   (dir != DIR_NONE ? dirGetName(dir) : specdir));
      }
      return success;
- #else
-     return try_exit(ch, exit, dir);
- #endif
    }
  }
  
--- 135,140 ----
***************
*** 150,204 ****
    };
  
    try_move(ch, subcmd, NULL);
- };
- 
- 
- //
- // cmd_enter is used to go through portals
- //   usage: enter [object]
- //
- //   examples:
- //     enter portal         enter the thing called "portal" in your room
- //
- COMMAND(cmd_enter) {
-   if(!arg || !*arg)
-     send_to_char(ch, "What did you want to enter?\r\n");
-   else {
-     int found_type = FOUND_NONE;
-     void *found = generic_find(ch, arg,
- 			       FIND_TYPE_OBJ | FIND_TYPE_EXIT,
- 			       FIND_SCOPE_IMMEDIATE,
- 			       FALSE, &found_type);
- 
-     // we're trying to enter a portal
-     if(found && found_type == FOUND_OBJ) {
-       if(objGetType(found) != ITEM_PORTAL)
- 	send_to_char(ch, "You can only enter portals.\r\n");
-       else {
- 	ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDestination(found));
- 	if(!dest)
- 	  send_to_char(ch, 
- 		       "You go to enter the portal, "
- 		       "but dark forces prevent you!\r\n");
- 	else {
- 	  send_to_char(ch, "You step through %s.\r\n", objGetName(found));
- 	  message(ch, NULL, found, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
- 		  "$n steps through $o.");
- 	  char_from_room(ch);
- 	  char_to_room(ch, dest);
- 	  look_at_room(ch, dest);
- 	  message(ch, NULL, found, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
- 		  "$n arrives after travelling through $o.");
- 	}
-       }
-     }
- 
-     // we're trying to enter an exit
-     else if(found && found_type == FOUND_EXIT)
-       try_exit(ch, found, DIR_NONE);
-     else
-       send_to_char(ch, "What were you trying to enter?\r\n");
-   }
  }
  
  
--- 150,155 ----
***************
*** 235,246 ****
    
    if(furniture == NULL)
      send_to_char(ch, "Where did you want to %s?\r\n", posGetActionSelf(pos));
!   else if(objGetType(furniture) != ITEM_FURNITURE)
      send_to_char(ch, "But that's not furniture!\r\n");
    // make sure we found something we might be able to sit on
    else if(charGetFurniture(ch) == furniture)
      send_to_char(ch, "You're already %s %s.\r\n",
! 		 (objGetSubtype(furniture) == FURNITURE_ON ? "on" : "at"),
  		 objGetName(furniture));
  
    else if(furnitureGetCapacity(furniture) <= listSize(objGetUsers(furniture)))
--- 186,197 ----
    
    if(furniture == NULL)
      send_to_char(ch, "Where did you want to %s?\r\n", posGetActionSelf(pos));
!   else if(!objIsType(furniture, "furniture"))
      send_to_char(ch, "But that's not furniture!\r\n");
    // make sure we found something we might be able to sit on
    else if(charGetFurniture(ch) == furniture)
      send_to_char(ch, "You're already %s %s.\r\n",
! 		 (furnitureGetType(furniture) == FURNITURE_ON ? "on" : "at"),
  		 objGetName(furniture));
  
    else if(furnitureGetCapacity(furniture) <= listSize(objGetUsers(furniture)))
***************
*** 260,271 ****
      char other_buf[SMALL_BUFFER];
      sprintf(other_buf, "$n %s %s $o.",	
  	    posGetActionOther(pos),
! 	    (objGetSubtype(furniture) == FURNITURE_ON ? "on" : "at"));
      message(ch, NULL, furniture, NULL, TRUE, TO_ROOM | TO_NOTCHAR, other_buf);
  
      send_to_char(ch, "You %s %s %s.\r\n",
  		 posGetActionSelf(pos),
! 		 (objGetSubtype(furniture) == FURNITURE_ON ? "on" : "at"),
  		 objGetName(furniture));
  
      // now sit down on the new thing
--- 211,222 ----
      char other_buf[SMALL_BUFFER];
      sprintf(other_buf, "$n %s %s $o.",	
  	    posGetActionOther(pos),
! 	    (furnitureGetType(furniture) == FURNITURE_ON ? "on" : "at"));
      message(ch, NULL, furniture, NULL, TRUE, TO_ROOM | TO_NOTCHAR, other_buf);
  
      send_to_char(ch, "You %s %s %s.\r\n",
  		 posGetActionSelf(pos),
! 		 (furnitureGetType(furniture) == FURNITURE_ON ? "on" : "at"),
  		 objGetName(furniture));
  
      // now sit down on the new thing
diff -crN nakedmudv1.5/src/movement.d nakedmudv2.0/src/movement.d
*** nakedmudv1.5/src/movement.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/movement.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ movement.d movement.o: movement.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h character.h world.h zone.h \
+   room.h exit.h movement.h handler.h inform.h utils.h object.h \
+   scripts/script.h items/items.h items/furniture.h
diff -crN nakedmudv1.5/src/mud.d nakedmudv2.0/src/mud.d
*** nakedmudv1.5/src/mud.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/mud.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ mud.d mud.o: mud.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h utils.h storage.h
